function result = run_bicgstab(x, y, b)
%% this function solves Au=b for u, using biconjugate gradient stabilized method "bicgstab".
%% instead of taking A as input, bicgstab takes a function "afun(v)" which returns the product Av at every input v.
%% variable x and y in this function serves as auxiliary variables that can be used by "afun".
%% for x and y to be available by  "afun", define "afun" inside this function. 

n = length(x); 
tol = 1e-9;  
maxit = 1000;  

result= bicgstab(@afun,b,tol,maxit );

    function Av = afun(v)
       Av =  SV( x, y, v ); %% write a seperate m file for a function SV that returns the product (I − g_y − g_x C)v, C as defined in the lecture notes.
    end 
end